/*
 *  CaSU - communications & status utilities.
 *  Copyright (C) 1992, 1993, 1994 Luke Mewburn <lm@rmit.edu.au>
 *	incorporating:
 *	   flon - lists your friends who are logged on.
 *	   to - send a short message to a friend
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include "casu.h"

static int	fd = -1;

/*
 * getutent -	support for boxes that need it
 */
utmp_s *
getutent()
{
    static utmp_s	buf;

    if (fd == -1)
    {
	fd = open(PATH_UTMP, O_RDONLY, 0);
	if (fd == -1)
	    return NULL;
    }
    if (read(fd, &buf, sizeof(buf)) <= 0)
	return NULL;
    return &buf;
}

void
endutent()
{
    close(fd);
}
